"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CoverageSummary(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "avg",
        "bases",
        "med",
        "scope",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.CoverageSummary": metrics_1_2_2.CoverageSummary,
        }

    __slots__ = [
        "avg",
        "bases",
        "med",
        "scope",
        "gte15x",
        "gte30x",
        "gte50x",
        "localRMSD",
        "lt15x",
        "pct25",
        "pct75",
        "sd",
    ]

    def __init__(
        self,
        avg,
        bases,
        med,
        scope,
        gte15x=None,
        gte30x=None,
        gte50x=None,
        localRMSD=None,
        lt15x=None,
        pct25=None,
        pct75=None,
        sd=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.CoverageSummary model.

        :param avg:
            Average coverage  renamed from mean
        :type avg: double
        :param bases:
            Number of bases  renamed from "n"
        :type bases: double
        :param med:
            median of the coverage  renamed from median
        :type med: double
        :param scope:
            Scope to which these summary stats refer to. *   Examples: "allchrs"
            (all chromosomes), "X", "chr6", "6", "autosomes"
        :type scope: str
        :param gte15x:
            Fraction of coverage values with a depth of coverage greater than or
            equal to 15x
        :type gte15x: None | double
        :param gte30x:
            Fraction of coverage values with a depth of coverage greater than or
            equal to 30x
        :type gte30x: None | double
        :param gte50x:
            Fraction of coverage values with a depth of coverage greater than or
            equal to 50x
        :type gte50x: None | double
        :param localRMSD:
            estimation of root mean square deviation: weighted average RMSD of
            chunks of 100k bases
        :type localRMSD: None | double
        :param lt15x:
            Fraction of coverage values with a depth of coverage less than 15x
        :type lt15x: None | double
        :param pct25:
            Percentile 25
        :type pct25: None | double
        :param pct75:
            Percentile 75
        :type pct75: None | double
        :param sd:
            Standard deviation of coverage values
        :type sd: None | double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
